IncludeScript("stopthattank/VoicelineRobotHelper.nut")

function Precache()
{
    if ( !("VoicelineRobotHelper" in getroottable()) )
    {
        ::VoicelineRobotHelper <- {};

        foreach (snd in PrecacheSounds)
        {
            self.PrecacheSoundScript(snd) //those text indentations matter a lot so keep an eye on them
        }

	    printl("Precaching The Sounds!"); //we really only need to precache the sounds once
    }
}

// Special thanks to Ash for helping me set this up!
function OnPostSpawn()
{
    AddThinkToEnt(self, "VoiceChange") //this will attach a "think" function to OnGameFrame below, making it run on every frame tick instead of once (the tick delay can be changed by editing the -1 of "return -1")
}

function VoiceChange()
{
    local ent = null;
    while (ent = Entities.FindByClassname(ent, "instanced_scripted_scene")) //this entity doesn't even exist in hammer, don't bother trying to understand it
    {
        local owner = NetProps.GetPropEntity(ent, "m_hOwner"); //who let out the specific voice line (aka probably you)
        if (owner != null) //if both exists and is in team blu
		{
            if ((owner.GetClassname() != "tf_taunt_prop") && (owner.GetClassname() == "player"))
            {
                if ((owner.GetTeam() == 3) || ((owner.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (owner.InCond(TF_COND_DISGUISED))))
                {
                    owner.AddCustomAttribute("voice pitch scale", 0.0, -1.0); //ficool2 used this to completely mute the player's voiceline. So that the human speech don't overlap with the new robotic one (and also to not accidentally let the robot let out human sounds which you didn't happen to replace yet.)
                    OnPlayerVoiceline(owner, ent);
                }
                else if((owner.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (!owner.InCond(TF_COND_DISGUISED)))
                {
                    owner.RemoveCustomAttribute("voice pitch scale"); //ficool2 used this to completely mute the player's voiceline. So that the human speech don't overlap with the new robotic one (and also to not accidentally let the robot let out human sounds which you didn't happen to replace yet.)
                }
            }
		}
        ent.KeyValueFromString("classname", "_scene"); //I seriously don't get this part either :shrug:
    }
    return -1 //ah there's the tick delay we mentioned earlier
}

::EmitPlayerVoiceline <- function(player, name)
{
    player.EmitSound(name);
}

// precache each footstep/weapon sound (decided to just use precache sound since there isn't a lot)

PrecacheSound("^mvm/mvm_deploy_giant.wav")
PrecacheSound("^mvm/mvm_deploy_small.wav")
PrecacheSound("^mvm/mvm_fallpain01.wav")
PrecacheSound("^mvm/mvm_fallpain02.wav")
PrecacheSound("^mvm/mvm_bomb_warning.wav")
PrecacheSound("^mvm/mvm_bomb_explode.wav")
PrecacheSound("^mvm/mvm_cpoint_klaxon.wav")

// Blu robot voice line array

::OnPlayerVoiceline <- function(player, scene)
{
    local name = null
    local vcdpath  = NetProps.GetPropString(scene, "m_szInstanceFilename")
    if (vcdpath)
    {
        for (local i = vcdpath.len() - 1, endindex = null; i >= 0; --i)
        {
            if (vcdpath[i] == 46) // '.'
                endindex = i
            else if (vcdpath[i] == 47 && endindex) // '/'
            {
                name = vcdpath.slice(i + 1, endindex);
                break; // thanks to Mince on discord for providing this part of code
            }
        }
    }
    if(name == null)
        return;
    if ((name[0] >= '0') && (name[0] <= '9'))
    {
        local index = name.tointeger();
        local playerClass
        if((player.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (player.InCond(TF_COND_DISGUISED)))
        {
            playerClass = NetProps.GetPropInt(player,"m_Shared.m_nDisguiseClass")
        }
        else
        {
            playerClass = player.GetPlayerClass()
        }
        foreach (vcdClasslist in VCDLists[playerClass])
        {
            local index = name.tointeger()
            foreach (vcd in vcdClasslist)
            {
                if (index == vcd[0])
                {
                    EntFireByHandle(self, "RunScriptCode", "EmitPlayerVoiceline(activator,`"+vcd[1]+"`)", 0.02, player, player);
                    break;
                }
            }
        }
    }
}
