//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

BOSS_BAR_UPDATE_PERIOD <- -1;   //Boss bar update period (in seconds). Set to -1 to update every tick (~0.015s).
                                 //Needs to be less than 1 second for the health number to display correctly.
BOSS_BAR_HIDE_ON_DEATH <- true;
BOSS_BAR_CHANGE_SPEED <- 500;     //The speed of animation in health points at which the bar moves when taking damage.

//====================================
//Don't edit past this line
//====================================

Convars.SetValue("tf_rd_points_per_approach", BOSS_BAR_CHANGE_SPEED + "");
SetPropInt <- ::NetProps.SetPropInt.bindenv(::NetProps);
pd_logic <- Entities.FindByClassname(null, "tf_logic_player_destruction");
::bossEntity <- null;
isHudVisible <- false;

::LeaderboardIcon <- [
    "../hud/leaderboard_class_tank", //0
    "../hud/leaderboard_class_scout", //1
    "../hud/leaderboard_class_sniper", //2
    "../hud/leaderboard_class_soldier", //3
    "../hud/leaderboard_class_demo", //4
    "../hud/leaderboard_class_medic", //5
    "../hud/leaderboard_class_heavy", //6
    "../hud/leaderboard_class_pyro", //7
    "../hud/leaderboard_class_spy", //8
    "../hud/leaderboard_class_engineer", //9
	//special
    "../hud/leaderboard_class_special_blimp", //10
	//scout special
    "../hud/leaderboard_class_scout_fan", //11
    "../hud/leaderboard_class_scout_stun", //12
	//sniper special
    "../hud/leaderboard_class_sniper_smg", //13
    "../hud/leaderboard_class_sniper_bow", //14
	//soldier special
    "../hud/leaderboard_class_soldier_bison", //15
    "../hud/leaderboard_class_soldier_barrage", //16
	//demo special
    "../hud/leaderboard_class_demoknight", //17
    "../hud/leaderboard_class_demo_burst", //18
    "../hud/leaderboard_class_demo_bomber", //19
    "../hud/leaderboard_class_demoknight_samurai", //20
	//medic special
    "../hud/leaderboard_class_medic_crossbow", //21
    "../hud/leaderboard_class_medic_syringe", //22
	//heavy special
    "../hud/leaderboard_class_heavy_deflector", //23
    "../hud/leaderboard_class_heavy_healonkill", //24
    "../hud/leaderboard_class_heavy_heater", //25
    "../hud/leaderboard_class_heavy_steelfist", //26
    "../hud/leaderboard_class_heavy_shotgun_burst", //27
    "../hud/leaderboard_class_heavy_shotgun", //28
	//pyro special
    "../hud/leaderboard_class_pyro_manmelter", //29
    "../hud/leaderboard_class_pyro", //30
    "../hud/leaderboard_class_pyro", //31
	//spy special
    "../hud/leaderboard_class_spy", //32
	//engineer special
    "../hud/leaderboard_class_engineer_pomson", //33
    "../hud/leaderboard_class_engineer_widowmaker", //34
	//i give up on the specifics ones lol
	 "../hud/leaderboard_class_demo_glock" //35
	 "../hud/leaderboard_class_heavy_mittens" //36
	 "../hud/leaderboard_class_scout_giant_fast" //37
	 "../hud/leaderboard_class_heavy_brassbeast" //38
	 "../hud/leaderboard_class_heavy_natascha_slow" //39
	 "../hud/leaderboard_class_pyro_flare" //40
];


function SpawnBossBar()
{
    if (pd_logic != null)
        return;
    pd_logic = SpawnEntityFromTable("tf_logic_player_destruction", {
        blue_respawn_time = 0,
        finale_length = 999999,
        flag_reset_delay = 0,
        heal_distance = 0,
        min_points = 255,
        points_per_player = 0,
        red_respawn_time = 0,
        targetname = "pd_logic",
        res_file = "resource/ui/custom_boss_bar.res"
    });
    SetPropInt(pd_logic, "m_nBlueScore", 0);
    SetPropInt(pd_logic, "m_nRedScore", 0);
    SetPropInt(pd_logic, "m_nBlueTargetPoints", 0);
    SetPropInt(pd_logic, "m_nRedTargetPoints", 0);
    SetPropInt(pd_logic, "m_nMaxPoints", 255);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", -1, null, null);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", 0.1, null, null);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", 1, null, null);
    EntFireByHandle(pd_logic, "EnableMaxScoreUpdating", "", -1, null, null);
    EntFireByHandle(pd_logic, "DisableMaxScoreUpdating", "", 5, null, null);
}
SpawnBossBar();

::UpdateBossBarLeaderboardIcon <- function(num)
{
    EntFire("pd_logic", "setcountdownimage", LeaderboardIcon[num], 0, null);
}

function SetBossBarValue(currentHP, maxHP, AllowBoss)
{
    if (currentHP > maxHP)
        maxHP = currentHP;
    if (currentHP > 1)
        currentHP++;
    SetPropInt(pd_logic, "m_nRedScore", Remap( PowerupTimer,  0,  180 / FrameTime(),  0,  maxHP));
    SetPropInt(pd_logic, "m_nRedTargetPoints", Remap( PowerupTimer,  0,  180 / FrameTime(),  0,  maxHP));
    SetPropInt(pd_logic, "m_nMaxPoints", maxHP);
	//printl(Remap( PowerupTimer,  0,  180,  0,  maxHP))
		if(AllowBoss)
		{
			SetPropInt(pd_logic, "m_nBlueScore", currentHP);
			SetPropInt(pd_logic, "m_nBlueTargetPoints", currentHP);
			EntFireByHandle(pd_logic, "setcountdowntimer", currentHP + "", 0, null, null);
		}

    if (floor(currentHP) <= 0 || floor(maxHP) <= 0)
    {

		//EntFireByHandle(pd_logic, "EnableMaxScoreUpdating", "", 0.1, null, null);
		//EntFireByHandle(pd_logic, "scorebluepoints", "-1", 0.3, null, null);
		//EntFireByHandle(pd_logic, "DisableMaxScoreUpdating", "", 5, null, null);
        //EntFireByHandle(pd_logic, "setcountdowntimer", "0", 0, null, null);
		SetPropInt(pd_logic, "m_nBlueScore", 0);
		SetPropInt(pd_logic, "m_nBlueTargetPoints", 0);
        SetPropInt(pd_logic, "m_nMaxPoints", -1);
		printl("Dead")
        isHudVisible = false;
		bossEntity = null;
    }
    else if (!isHudVisible)
    {
        isHudVisible = true;
    }
}

function Think()
{
    if (!bossEntity || !bossEntity.IsValid()
        || bossEntity.GetMaxHealth() <= 0
        || (BOSS_BAR_HIDE_ON_DEATH && NetProps.GetPropInt(bossEntity, "m_lifeState") != 0))
    {
        if (isHudVisible)
		{
            SetBossBarValue(0, 0, false);
			EntFireByHandle(pd_logic, "setcountdowntimer", 0 + "", 0, null, null);
			//printl("ThinkDead")
		}
        return BOSS_BAR_UPDATE_PERIOD;
    }
	else
	{
		local AllowBoss = false
		//printl("Think")
		if(bossEntity.GetClassname() == "tank_boss")
		{
			AllowBoss = true
		}
		else if(bossEntity.IsPlayer() && bossEntity.IsMiniBoss())
		{
			AllowBoss = true
		}

		SetBossBarValue(bossEntity.GetHealth(), bossEntity.GetMaxHealth(), AllowBoss);
		return BOSS_BAR_UPDATE_PERIOD;
	}
}

::SetBossEntity <- function(newBossEntity)
{
    bossEntity = newBossEntity;
}

/*
This is how we make CompilePal include custom files.
PrecacheModel("resource/ui/custom_boss_bar.res");
PrecacheModel("materials/hud/custom_boss_bar.vmt");
PrecacheModel("materials/hud/custom_boss_bar.vtf");
PrecacheModel("materials/hud/custom_boss_bar_surround.vmt");
PrecacheModel("materials/hud/custom_boss_bar_surround.vtf");
*/